$INTERFACE U1FDN3                                             97/12/01
$REM LU
  $N='N'
  $AZS='AZ'
  $ADD(REAL,'\UXVDOT')
  $NA='2*$NC+1'
  $ADD(REAL,'\$AFO($NA)')
  $ADD(INTEGER,'\IMD')
  $NA='2*$NC+1'
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
      C - GENERAL TRUST REGION WITH SECOND ORDER CORRECTION
  $CHECK(TYPE,'L','L\G\C',2,NO)
  $SUBP='Q'
  $HELP
    QUADRATIC PROGRAMMING METHOD:
      1 - DUAL QUADRATIC PROGRAMMING METHOD
      2 - PRIMAL QUADRATIC PROGRAMMING METHOD
  $CHECK(NUMBER,'1','1\2',2,NO)
  $IF(TYPE='L')
    $KDS=0
    $HELP
      LINE SEARCH INTERPOLATION
        1 - BISECTION
        2 - TWO POINT QUADRATIC INTERPOLATION
        3 - THREE POINT QUADRATIC INTERPOLATION
        4 - THREE POINT CUBIC INTERPOLATION
        5 - SPECIAL INTERPOLATION
    $CHECK(MES,1,'1\2\3\4\5',3)
    $STEP=1
    $IF(MES=5) $STEP=5
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
       -1 - SPECIAL INITIAL STEPSIZE FOR THE MINIMAX APPROXIMATION
        1 - UNIT INITIAL STEPSIZE
    $CHECK(INITS,1,'-1\1',4)
    $LCS=0
  $ELSE
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
    $IXA='IXA'
    $NX=NF
    $LCS=1
    $ADD(INIT)
      LCS=1
    $ENDADD
    $ADD(SINIT)
      $SUBST('UYINV1')
      CALL UXVINS(NF,-1,$IXA)
    $ENDADD
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2',4)
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - OPTIMALLY CONDITIONED UPDATE
      6 - SIMPLE PRECONVEX UPDATE
      7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
      8 - NEW COMBINED UPDATE
      9 - PRECONVEX UPDATE DERIVED FROM MATRIX FACTORIZATION
     10 - ANGLE MINIMIZING UPDATE
     11 - NORM MINIMIZING UPDATE
     12 - LPD UPDATE
  $CHECK(MET,1,'1\2\3\4\5\6\7\8\9\10\11\12',3)
  $HELP
    SELECTION OF SELF SCALING:
      1 - SELF SCALING SUPPRESSED
      2 - INITIAL SELF SCALING
      3 - CONTROLLED SELF SCALING
      4 - SIMPLIFIED CONTROLLED SELF SCALING
      5 - SELF SCALING IN EACH ITERATION
  $CHECK(MET1,2,'1\2\3\4\5',4)
  $HELP
    SELECTION OF THE LINE SEARCH MODEL:
      1 - QUADRATIC MODEL
      2 - BASIC USE OF TAYLOR EXPANSION
      3 - MODIFIED USE OF TAYLOR EXPANSION
      4 - HOMOGENEOUS MODEL
      5 - CUBIC MODEL
  $CHECK(MET2,1,'1\2',4)
  $HELP
    METHOD CORRECTION:
      1 - NO CORRECTION
      2 - POWELL'S CORRECTION
  $CHECK(MET3,1,'1\2',4)
  $HELP
    PENALTY PARAMETER
  $CHECK(RPF1,'5.0$P 0',REAL,4)
  $HELP
    PENALTY PARAMETER
  $CHECK(RPF2,'1.0$P-3',REAL,4)
  $HELP
    PENALTY PARAMETER
  $CHECK(RPF3,'5.0$P 0',REAL,4)
  $MAL=NA
  NDECF=0
  $SUBST('UCSET5')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NCL>0)
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
  $ENDIF
  $IF (KBF>0) $SUBST('UYFPS1')
*
*     ----------------------------------------
*     RECURSIVE MINIMAX VARIABLE METRIC METHOD
*     TEMPLATE : U1FDN3
*     ----------------------------------------
*
  $LMD=$10
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  NIC=1
$L=$10 ; $LABEL
  $KD=1 ; $IF(INITH=3) $KD=2
  $SUBST('UP1MX2')
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 30 ; $LABEL
  $SUBST('UO2FN3')
  $SUBST('UYFUT2')
  IF(ITERM.NE.0) GOTO $90
$L=$ 40 ; $LABEL
  N=NF
  $SUBST('UUDSD1')
  IF (ITERM.NE.0) GO TO $90
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDDX$(SUBP)1
*     -----------------------
*
  $SUBST('UDDX$(SUBP)1')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)2')
  IF (GMAX.LE.TOLG.AND.CMAX.LE.TOLC) THEN
  ITERM=4
  TXFU='GRAD TOL'
  ENDIF
  IF(ITERM.NE.0) GOTO $90
  IF(IREST.NE.0) GOTO $40
  IF (GMAX.GE.RPF2*CMAX.OR.CMAX.LE.TOLC) GO TO $50
  IF (NIC.GE.MIC) THEN
  ITERM=14
  TXFU='IC LIMIT'
  CALL UOERR1('U1FDN3',-4)
  GOTO $90
  ENDIF
  RPF1=RPF1*RPF3**NIC
  NIC=NIC+1
  CALL UYSET2
  ASSIGN $40 TO IMD
  GO TO $10
$L=$ 50 ; $LABEL
  $IF($DEF(MES))
    $IF(MES=5) $SUBST('UAMAXD')
    $IF(INITS=-1) $SUBST('UASTEP')
  $ENDIF
  $SUBST('UYTRUS')
  CALL UXVCOP(NA,$AF,$AFO)
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  $IF(TYPE='C')
    $GOTO ($74,$72,$70) ISB+1
$L=$ 70 ; $LABEL
    $AZS='AZS'
    $SUBST('UYSETA')
*
*     --------------------------------
*     BEGIN OF DIRECTION DETERMINATION
*     --------------------------------
*
    $SUBST('UDDX$(SUBP)1')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
    P=UXVDOT(NF,$G,$S)
    GO TO $60
  $ELSE
    GOTO ($74,$72) ISB+1
  $ENDIF
$L=$ 72 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 74 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  CALL UXVCOP(NA,$AFO,$AF)
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $40
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $40
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  $IF(SUBP='Q')
    $GN='G'
    $SN='S'
    $IF(MCL=0)
      $SUBST('UYTRAD')
    $ELSE
      $SUBST('UYTRFD')
    $ENDIF
    $IF($DEF(MCG))
      $IF(MCG<>0)
        $IF(MCG1=1)
          $SUBST('UYUPND')
        $ENDIF
      $ENDIF
    $ENDIF
    $IHLP=2
    $IF(MET=1) $IHLP=1
    $DEC='G'
    $SUBST('UUDB$(DEC)$(IHLP)')
  $ENDIF
  IF (ITERH.NE.0) CALL UYRES1('UPDATE  ')
  GOTO $30
$L=$ 90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $NA=0
  $SUBST('UO1FN2')
  $ADD(INIT)
    NXFU='U1FDN3'
  $ENDADD
  $EXIT
