$INTERFACE U1FLU7                                             04/12/01
$REM VL
  $AX='AX'
  $AY='AY'
  $AZ='AZ'
  $XM='XM'
  $GM='GM'
  $XR='XR'
  $GR='GR'
  $HR='HR'
  $XM1='XM1'
  $GM1='GM1'
  $XR1='XR1'
  $GR1='GR1'
  $HR1='HR1'
  $U1='U1'
  $U2='U2'
  $N='NF'
  $HELP
    NUMBER OF BFGS CORRECTIONS
  $CHECK(MF,10,INT,2)
  $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR($MF*($MF+1)/2)&
  $GR($MF*($MF+1)/2)\$HR($MF*($MF+1)/2)\$U1($NF)\$U2($NF)')
  $ADD(INTEGER,'\IMD')
  $HERF='L'
  $CON1='2.5$P-1'
  $ADD(REAL,'\ALFN\ALFV\GAM\RHO\DF\POM')
  $ADD(REAL,'\UXVDOT\UXVSAB\UXVNOR')
  $HELP
    MAXIMUM NUMBER OF TESTS ON STEPLENGTH
  $CHECK(MTESX,10,INT,4)
  $HELP
    MAXIMUM NUMBER OF TESTS ON FUNCTION DECREASE
  $CHECK(MTESF,10,INT,4)
  $HELP
    UPDATE OF THE LBFGS MATRIX AFTER DESCENT STEP:
      0 - UPDATE IS SKIPPED
      1 - UPDATE IS USED
  $CHECK(MET,1,'0\1',3)
  $HELP
    UPDATES IN NULL STEPS:
      0 - NO UPDATES IN NULL STEPS
      1 - RANK ONE UPDATES IN MF1 CONSECUTIVE NULL STEPS
      2 - RANK ONE UPDATES IN ALL NULL STEPS
      3 - BFGS UPDATES IN ALL NULL STEPS
  $CHECK(MET2,1,'0\1\2\3',4)
  $IF(MET2=0) $MET=0
  $HELP
    NUMBER OF RANK-ONE CORRECTIONS
  $CHECK(MET3,MF,INT,2,NO)
  $MF1=MET3
  $IF(MF1< 0) $MF1=0
  $IF(MF1>MF) $MF1=MF
  $IF(MET2=3)
    $MET=0
    $HELP
      NUMBER OF BFGS UPDATES IN THE NULL STEPS
    $CHECK(MET4,5,INT,4)
  $ENDIF
  $GM2=GM1
  $IF (MET=1) $GM2='GM2'
  $HELP
    TYPE OF PROBLEM:
      0 - CONVEX PROBLEM
      1 - NONCONVEX PROBLEM
  $CHECK(MEX,1,'0\1',3)
  $HELP
    TYPE OF DIRECTION VECTOR CORRECTION
      0 - BASIC ALGORITHM
      1 - RESTART IF THE DIRECTION VECTOR IS SHORT
      2 - CONTROLLED CORRECTION OF THE DIRECTION VECTOR
      3 - PERMANENT  CORRECTION OF THE DIRECTION VECTOR
  $CHECK(MEX1,0,'0\1\2\3',3)
  $HELP
    TERMINATION CRITERION:
      0 - BASIC CRITERION
      1 - EXTENDED CRITERION FOR LARGE PROBLEMS
  $CHECK(MEX2,0,'0\1',3)
  $HELP
    TERMINATION OR EXTRAPOLATION AFTER ZERO DIFFERENCE OF GRADIENTS:
      0 - TERMINATION
      1 - EXTRAPOLATION WITH CONSTANT STEPSIZE
      2 - EXTRAPOLATION WITH INCREASING STEPSIZE
  $CHECK(MEX3,0,'0\1\2',3)
  $IF(MEX1>1)
    $HELP
      CORRECTION PARAMETER
    $CHECK(ETA3,'1.0$P-12',REAL,4)
  $ENDIF
  $ADD(INTEGER,'\JC\JE\JR\NNK\NNV\IRT')
  $HELP
    NUMBER OF BUNDLE POINTS:
  $CHECK(MB,20,INT,2,NO)
  $IF(MB<=0) $MB=20
  $ADD(INIT)
    MB=$MB
  $ENDADD
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $TYPE='L'
  $DECOMP='I'
  $NUMBER=1
  $KDS=1
  $IF(TYPE='L')
    $LCS=0
    $IF(MEX=0)
      $STEP=7
      $CON1='2.0$P 0'
      $CON2='1.0$P 0'
    $ELSE
      $STEP=8
      $CON1='1.0$P 2'
      $CON2='1.0$P-1'
    $ENDIF
    $MES3=0
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2',4)
$REM  $UPDATE='V'
  $IF(MEX=0)
    $ETA5='0.0$P 0'
  $ELSE
    $HELP
      CORRECTION PARAMETER
    $CHECK(ETA2,'1.0$P-12',REAL,4)
    $HELP
      LOCALITY MEASURE EXPONENT (SEE MANUAL UFO)
        1 - EXPONENT ONE
        2 - EXPONENT TWO
    $CHECK(MOS3,2,'1\2',3)
    $HELP
      MEASURE OF NONCONVEXITY
    $CHECK(ETA5,'0.25$P 0',REAL,3)
  $ENDIF
  $IRES1=111
  $IRES2=999
  $ADD(INIT)
    ISNA=$ISNA
  $ENDADD
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
$REM  N=NF
  $IF(NAL>0)
    $MAL='$NAL'
    $ADD(INIT)
      MAL=NAL
    $ENDADD
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  IF (ITERM.NE.0) GOTO $90
*
*     -----------------------------
*     BUNDLE VARIABLE METRIC METHOD
*     TEMPLATE : U1FLU7
*     -----------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  NB=0
  MB=$MB
  IF (MB.GT.NF) MB=NF+3
  JR=0
  $IF(MEX=1)
    JE=0
  $ENDIF
  NNK=0
  NNV=0
  $IF(.FALSE.)
    GAM=ONE
  $ENDIF
$L=$10 ; $LABEL
  $KD=1 ; $IF(INITH=3) $KD=2
  $SUBST('UZMODN')
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF(TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF(TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  DF=ABS(F)+ONE
  $SUBST('UYBUN1')
$L=$30 ; $LABEL
  ITES=-1
  IF (ITERS.GT.0) THEN
  JC=0
  ALFN=ZERO
  ALFV=ZERO
  CALL UXVCOP(NF,$G,$GP)
  ENDIF
  $GH=G
  $G=GP
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT5')
  IF (ITERM.NE.0) GO TO $90
  $IF(CONSTR='C')
    IF (RMAX.GT.ZERO) THEN
    $SUBST('UYRM$(CONSTR)0')
    ENDIF
  $ENDIF
  $G=GH
$L=$40 ; $LABEL
  IF (IREST.GT.0) THEN
  JC=0
  NN=0
  NN1=0
  NNK=0
  ALFN=ZERO
  ALFV=ZERO
  CALL UXVCOP(NF,$G,$GP)
  TUXX='UNIT    '
  LD=MIN(LD,1)
  CALL UYSET3
  ENDIF
  IF (ITERM.NE.0) GO TO $90
  $IF(MEX=1)
    IF (JE.GT.0) GO TO $50
  $ENDIF
  $MAT='L'
  $DECOMG='N'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$NUMBER
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$NUMBER')
  $IF(MEX1=3)
    JC=1
  $ELSEIF(MEX1=2)
    IF (-UXVDOT(NF,GP,S).LE.1.0D-10*GNORM**2) JC=1
  $ENDIF
  $IF(MEX1>1)
    IF (JC.EQ.1) THEN
    CALL UXVDIR(NF,-ETA3,GP,S,S)
    $IF(CONSTR='C')
      SNORM=SQRT(UXUDOT(NF,S,S,IX,KBF))
    $ELSE
      SNORM=SQRT(UXVDOT(NF,S,S))
    $ENDIF
    ENDIF
  $ENDIF
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(TYPE='L')
    $SUBST('UD1T$(TYPE)1')
    $IF(MEX1=1)
      IF(SNORM.LE.ETA0*GNORM) THEN
      CALL UYRES1('ZERO DIR')
      ENDIF
    $ENDIF
    IF (ITERS.EQ.0) IREST=0
    IF (SNORM.LE.ZERO) IREST=0
  $ENDIF
  IF (ITERM.NE.0) GO TO $90
  IF (IREST.NE.0) GO TO $40
  XNORM=-P+TWO*ALFV
$L=$50 ; $LABEL
  $SUBST('UYFUT6')
  IF (ITERM.NE.0) GO TO $90
  $IF(MEX=0)
    POM=1.0$P-4*XNORM
  $ENDIF
  $IF(TYPE='L')
    IF (SNORM.GT.ZERO) RMAX=XMAX/SNORM
    RMIN=1.0$P-10
  $ENDIF
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $85
  $ENDIF
$L=$60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GO TO ($64,$62) ISB+1
$L=$62 ; $LABEL
  $IF(CONSTR='C')
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
    $SUBST('UCBS04')
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GO TO $10
$L=$64 ; $LABEL
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$80 ; $LABEL
  TXFU=TUXX
  $LMF=$90
  $SUBST('UYFUT7')
  $SUBST('UYBUN1')
  $IF(.FALSE.)
    IF (RP.LT.SQRT($ETA9)) THEN
    GAM=(MAX($CON2,MIN(1.0$P 2,RP))+TWO*GAM)/THREE
    ENDIF
    IRT=0
  $ENDIF
  IF (ITERS.EQ.0) THEN
  NNK=NNK+1
  $IF(MEX=0)
    ALFN=ABS((FO-F)/R+P)
  $ELSE
    ALFN=MAX(ABS(FO-F+P*R),ETA5*(SNORM*R)**MOS3)
  $ENDIF
  IF (NNK.EQ.1) THEN
  $SUBST('UYAH$(CONSTR)2')
  ELSE
  $SUBST('UYAH$(CONSTR)1')
  ENDIF
  F=FO
  PO=R*PO
  ELSE
  NNK=0
  $IF (MET=0)
    NN1=0
  $ELSE
    $SUBST('UYHRUP')
  $ENDIF
  $IF(.FALSE.)
    IF (GAM.GT.ONE) JR=JR+1
    IF (GAM.GT.TEN.AND.NNV.GT.3.AND.JR.GT.1) THEN
*
*     MATRIX SCALING
*
    NNV=0
    JR=0
    CALL UXVSCL(NF*MF,GAM,$H,$H)
    GAM=SQRT(GAM)
    IRT=1
    ENDIF
  $ENDIF
  ENDIF
  POM=P
  $SUBST('UYTR$(CONSTR)D')
  $IF(CONSTR='C')
    CALL UXUZER(NF,$GO,$IX,KBF)
    CALL UXUCOP(NF,$G,$SO,$IX,KBF)
  $ENDIF
  P=POM
  POM=UXVSAB(NF,$GO)
  $IF(.FALSE.)
    IF (IRT.GT.0) THEN
    IF (POM.NE.ZERO) JE=0
    GO TO $85
    ENDIF
  $ENDIF
  $IF(MEX=0)
    $KHLP='1.0D-5*SNORM**2'
  $ELSE
    IF (POM.EQ.ZERO.AND.ITERS.GT.0) THEN
    $IF(MEX3=0)
      ITERM=6
      TXFU='ZERO DIF'
      GO TO $90
    $ELSE
      JE=JE+1
      $IF(MEX3=1)
        IF (JE.GT.1) JE=99
      $ENDIF
      GO TO $85
    $ENDIF
    ELSE
    JE=0
    ENDIF
    $KHLP='ZERO'
  $ENDIF
  TUXX='SKIP UP.'
  POM=UXVDOT(NF,$XO,$GO)
  IF (ABS(POM).GT.1.0$P-6*UXVNOR(NF,XO)*UXVNOR(NF,GO)) THEN
  $IF(MET2=3)
    IF (NNK.GT.MET4) GO TO $85
  $ENDIF
  $SUBST('UULBI2')
  ENDIF
$L=$85 ; $LABEL
  $IF(CONSTR='C') $SUBST('UYADC0')
  GO TO $30
$L=$90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  GMAX=XNORM
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FLU7'
  $ENDADD
  $EXIT
