$INTERFACE U2FSU5                                             04/12/01
$REM VL
  $AX='AX'
  $AY='AY'
  $AZ='AZ'
  $AGP='AGP'
  $N='NF'
  $HERF='S'
  $HESR='B'
  $ADD(REAL,'\ALFN\ALFV\GAM\DF\POM')
  $ADD(REAL,'\UXVDOT\UXVSAB\UXVNOR')
  $HELP
    TYPE OF PROBLEM:
      0 - CONVEX PROBLEM
      1 - NONCONVEX PROBLEM
  $CHECK(MEX,1,'0\1',3)
  $IF(MEX=0)
    $ADD(INTEGER,'\JE\JR\NNK\NNV\IRT')
  $ELSE
    $ADD(INTEGER,'\JE\JR\NNK\NNV\IRT')
  $ENDIF
  $ADD(INTEGER,'\IMD')
  $HELP
    NUMBER OF BUNDLE POINTS:
  $CHECK(MB,0,INT,2,NO)
  $IF(MB<=0)  $MB='$NF+3'
  $ADD(INIT)
    MB=$MB
  $ENDADD
  $TYPE='L'
  $DECOMP='M'
  $NUMBER=1
  $KDS=1
  $IF(TYPE='L')
    $LCS=0
    $IF(MEX=0)
      $STEP=7
      $CON1='2.0$P 0'
      $CON2='1.0$P 0'
    $ELSE
      $STEP=8
      $CON1='1.0$P 2'
      $CON2='1.0$P-1'
    $ENDIF
    $MES3=0
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2',4)
  $UPDATE='V'
  $IF(UPDATE='V')
    $SUBST('UFSET2')
    $ISNA=2
    $ADD(INIT)
      ISNA=2
    $ENDADD
  $ELSE
    $HESR='S'
  $ENDIF
  $IF(MEX=0)
    $HELP
      INITIAL CORRECTION PARAMETER
    $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ETA5='0.0$P 0'
  $ELSE
    $HELP
      CORRECTION PARAMETER
    $CHECK(ETA2,'1.0$P-12',REAL,4)
    $HELP
      LOCALITY MEASURE EXPONENT (SEE MANUAL UFO)
        1 - EXPONENT ONE
        2 - EXPONENT TWO
    $CHECK(MOS3,2,'1\2',3)
    $HELP
      MEASURE OF NONCONVEXITY
    $CHECK(ETA5,'0.25$P 0',REAL,3)
  $ENDIF
  $IRES1=111
  $IRES2=999
  $ADD(INIT)
    ISNA=$ISNA
  $ENDADD
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  NDECF=0
  $SUBST('UFSET1')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
$REM  N=NF
  $IF(NAL>0)
    $MAL='$NAL'
    $ADD(INIT)
      MAL=NAL
    $ENDADD
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  $IF(NUMBER=1)
    $SUBST('UYSFSH')
  $ENDIF
  $DEC='G'
  IF (ITERM.NE.0) GOTO $90
*
*     -----------------------------
*     BUNDLE VARIABLE METRIC METHOD
*     TEMPLATE : U2FSU5
*     -----------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  NB=0
  MB=$MB
  IF (MB.GT.NF) MB=NF+3
  JR=0
  $IF(MEX=1)
    JE=0
  $ENDIF
  NNK=0
  NNV=0
  GAM=ONE
$L=$10 ; $LABEL
  $KD=2
  $SUBST('UZMODN')
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  DF=ABS(F)+ONE
  $SUBST('UYBUN1')
$L=$30 ; $LABEL
  ITES=-1
  IF (ITERS.GT.0) THEN
  ALFN=ZERO
  ALFV=ZERO
  CALL UXVCOP(NF,$G,$GP)
  ENDIF
  $GH=G
  $G=GP
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT5')
  IF (ITERM.NE.0) GO TO $90
  $IF(CONSTR='C') $SUBST('UYRM$(CONSTR)0')
  $G=GH
$L=$40 ; $LABEL
  $SUBST('UU$(HESR)SD1')
  IF (ITERM.NE.0) GO TO $90
  $IF(CONSTR='C')
    CALL UXVINB(NF,M,$IX,$JH)
    $IF(HESR='B') CALL UXVINB(NF,MA,$IX,$JAG)
  $ENDIF
  $IF(HESR='B')
    $HELP
      MAXIMUM SIZE OF THE PARTITIONED HESSIAN MATRIX
    $CHECK(MAH,'25*$NA',INT,1)
    CALL UXVSET($IH(NF+1)-1,ZERO,$H)
    CALL UFSET4(NF,NA,NAL,MA,MAH,M,$H,$IH,$JH,$AH,$IAG,$JAG)
    $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\$IAG($NA+1)\$JAG($MA)')
    $ADD(REAL,'\$H($M)\$AH($MAH)')
$REM    $SUBST('UFSET4')
  $ENDIF
  $SUBST('UYTS$(CONSTR)H')
  $IF(MEX=1)
    IF (JE.GT.0) GO TO $50
  $ENDIF
  $MAT='G'
  $DEC='G'
  $DECOMG='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$NUMBER
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$NUMBER')
  TXFU=TDXX
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(TYPE='L')
    $SUBST('UD1T$(TYPE)1')
    IF (SNORM.LE.ZERO) IREST=0
  $ENDIF
  IF (ITERM.NE.0) GO TO $90
  IF (IREST.NE.0) GO TO $40
  XNORM=-P+TWO*ALFV
$L=$ 50 ; $LABEL
  $SUBST('UYFUT6')
  IF (ITERM.NE.0) GO TO $90
  $IF(MEX=0)
    POM=1.0$P-4*XNORM
  $ENDIF
  $IF(TYPE='L')
    IF (SNORM.GT.ZERO) RMAX=XMAX/SNORM
    RMIN=1.0$P-10
  $ENDIF
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
  IF (RMAX.LE.RMIN) THEN
  R=ZERO
  GO TO $85
  ENDIF
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GO TO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  $IF(CONSTR='C')
    $IF(TYPE='G')
      CALL UXVDIR(NF,R,$S,$XO,$X)
    $ELSE
      CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
    $ENDIF
    $SUBST('UCBS04')
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GO TO $10
$L=$ 64 ; $LABEL
  TXFU=TSXX
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  $LMF=$90
  $SUBST('UYFUT7')
  $SUBST('UYBUN1')
  IF (RP.LT.SQRT($ETA9)) GAM=(MAX($CON2,MIN(1.0$P 2,RP))+TWO*GAM)/THREE
  IRT=0
  IF (ITERS.EQ.0) THEN
  NNK=NNK+1
  $IF(MEX=0)
    ALFN=ABS((FO-F)/R+P)
  $ELSE
    ALFN=MAX(ABS(FO-F+P*R),ETA5*(SNORM*R)**MOS3)
  $ENDIF
  $AM=AH
  $MAM=MAH
  MAM=MAH
  IF (NNK.EQ.1) THEN
  $SUBST('UYAB$(CONSTR)2')
  ELSE
  $SUBST('UYAB$(CONSTR)1')
  ENDIF
  F=FO
  ELSE
  NNK=0
  $IF(MEX=0)
    RHO=ETA2/NFV
    IF (GNORM.GT.ZERO) RHO=RHO*MIN(ONE/MIN(GNORM**2,1.0$P 3),GNORM**2)
  $ENDIF
  IF (GAM.GT.ONE) JR=JR+1
  IF (GAM.GT.TEN.AND.NNV.GT.3.AND.JR.GT.1) THEN
*
*     MATRIX SCALING
*
  NNV=0
  JR=0
  CALL UXVSCL(MAH,GAM,$AH,$AH)
  GAM=SQRT(GAM)
  IRT=1
  ENDIF
  ENDIF
  POM=P
  $SUBST('UYTR$(CONSTR)D')
  $IF(CONSTR='C') CALL UXVINB(NF,M,$IX,$JH)
  P=POM
  POM=UXVSAB(NF,$GO)
  IF (IRT.GT.0) THEN
  IF (POM.NE.ZERO) JE=0
  GO TO $85
  ENDIF
  $IF(MEX=0)
    $KHLP='1.0D-5*SNORM**2'
  $ELSE
    IF (POM.EQ.ZERO.AND.ITERS.GT.0) THEN
    JE=JE+1
    IF (JE.GT.7) JE=99
    GO TO $85
    ELSE
    JE=0
    ENDIF
    $KHLP='ZERO'
  $ENDIF
$L=$ 85 ; $LABEL
  $KHLP=4
  $IF(MLC=1) $KHLP=0
  $IF(CONSTR<>'U')
    IF (ITERS.NE.0.OR.RMAX.LE.RMIN.AND.INEW.NE.0) THEN
    $SUBST('UYAD$(CONSTR)$(KHLP)')
    ENDIF
  $ENDIF
  GO TO $30
$L=$ 90 ; $LABEL
  GMAX=XNORM
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U2FSU5'
  $ENDADD
  $EXIT
