$INTERFACE UDGLG2                                             16/12/01
$REM LU
  $IF($DEF(KDS))
  $ELSE
    $DEFAULT=0
    $IF(KDF>0) $DEFAULT=1
    $IF(KDA>0) $DEFAULT=1
    $IF(KDE>0) $DEFAULT=1
    $IF(KDY>0) $DEFAULT=1
    $IF(DEFAULT=1)
      $HELP
        DEGREE OF DIRECTIONAL DERIVATIVES IN LINE SEARCH:
          0 - NO DIRECTIONAL DERIVATIVES
          1 - FIRST DIRECTIONAL DERIVATIVES
      $CHECK(KDS,$DEFAULT,'0\1',4,NO)
    $ELSE
      $KDS=0
    $ENDIF
  $ENDIF
  $HELP
    TERMINATION CRITERION:
      NEGATIVE-NONMONOTONE STEPSIZE
               (= MINUS NUMBER OF NONMONOTONE STEPS)
             1-PERFECT LINE SEARCH
             2-GOLDSTEIN STEPSIZE
             3-WEAK WOLFE STEPSIZE
             4-STRONG WOLFE STEPSIZE
             5-ARMIJO STEPSIZE
  $CHECK(KTERS,3,'-10\-9\-8\-7\-6\-5\-4\-3\-2\-1\1\2\3\4\5',3)
  $IF(KTERS>0) $STEP=2
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0D-3',REAL,4)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA3,'1.0$P 2',REAL,4)
  $ADD(REAL,'\$H($M)\$GN($NF)\$SN($NF)\$XO($NF)')
  $ADD(REAL,'\UXVDOT')
  $ADD(REAL,'\ALF\BET')
  CALL UOD1D1
  IF (IDECF.LT.0) THEN
  $IF(HERF='D')
    $ADD(REAL,'\UXVDOT')
    $POM1='V'
    $POM2=')'
    $N='N'
    $IF(DEC='M')
      $HELP
         TYPE OF DECOMPOSITION
           0 - GILL-MURRAY DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,0,'0\1\2',2)
      $IF(MOS2=0)
      $ELSE
        $IF(MOS2=1)
          $LET='L'
          $ART=',$IB)'
          $ADD(INTEGER,'\$IB($NF)')
        $ELSE
          $LET='S'
          $ART=')'
        $ENDIF
        $ADD(INTEGER,'\$IH($NF)')
        CALL UXVINP($N,$IH)
      $ENDIF
      $IDECF=0
      IDECF=0
      INF=1
      ENDIF
      $ADD(REAL,'\$B($M)')
      CALL UXDSMC($N,$H,$B)
      $HS=H
      $H=B
      $IF(MOS2=0)
        TDXX(1:4)='G-M '
      $ELSE
        TDXX(1:4)='S-E '
      $ENDIF
      IF (IDECF.EQ.0) THEN
      $IF(MOS2=0)
*
*     GILL-MURRAY DECOMPOSITION
*
        ALF=ETA2
        CALL UXDPGF($N,$H,INF,ALF,BET)
      $ELSE
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
        ALF=ETA2
        CALL UXD$(LET)GF($N,$H,$IH,$SN,INF,ALF,BET$ART
      $ENDIF
      NDECF=NDECF+1
    $ELSEIF(DEC='G')
      $IDECF=1
      IDECF=1
      INF=1
      ENDIF
      TDXX(1:4)='G-M '
      IF (IDECF.EQ.0) THEN
*
*     GILL-MURRAY DECOMPOSITION
*
      ALF=ETA2
      CALL UXDPGF($N,$H,INF,ALF,BET)
      NDECF=NDECF+1
      IDECF=1
      ELSE IF (IDECF.EQ.1) THEN
      ELSE IF (IDECF.EQ.2) THEN
      CALL UXDPRT($N,$H)
      IDECF=1
    $ELSEIF(DEC='S')
      $HELP
         TYPE OF DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2',2)
      $IF(MOS2=1)
        $LET='L'
        $ART=',$IB)'
        $ADD(INTEGER,'\$IB($NF)')
      $ELSE
        $LET='S'
        $ART=')'
      $ENDIF
     $ADD(INTEGER,'\$IH($NF)')
      CALL UXVINP($N,$IH)
      $IDECF=4
      IDECF=4
      INF=1
      ENDIF
      TDXX(1:4)='S-E '
      IF (IDECF.EQ.0) THEN
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
      ALF=ETA2
      CALL UXD$(LET)GF($N,$H,$IH,$SN,INF,ALF,BET$ART
      NDECF=NDECF+1
      IDECF=4
      ELSE IF (IDECF.EQ.1) THEN
      CALL UXVINP($N,$IH)
      IDECF=4
      ELSE IF (IDECF.EQ.2) THEN
      CALL UXDPRT($N,$H)
      CALL UXVINP($N,$IH)
      IDECF=4
      ELSE IF (IDECF.EQ.4) THEN
      ELSE IF (IDECF.EQ.5) THEN
      CALL UXDSRT($N,$H,$IH)
      IDECF=4
    $ELSEIF(DEC='B')
      $ADD(INTEGER,'\$IH($NF)')
      $HELP
         TYPE OF DECOMPOSITION
           1 - BUNCH-PARLETT DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - BUNCH-KAUFMAN DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           3 - BUNCH PARLETT DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2\3',2)
      $IF(MOS2<3)
        $LET='L'
        $ART=',MOS2'
$REM        $ADD(REAL,'\UXDLBQ')
      $ELSE
        $LET=S
        $ART=')'
$REM        $ADD(REAL,'\UXDSBQ')
      $ENDIF
      CALL UXVINP($N,$IH)
      $IDECF=3
      IDECF=3
      INF=1
      ENDIF
      TDXX(1:4)='B-P '
      IF (IDECF.EQ.0) THEN
*
*     BUNCH PARLETT DECOMPOSITION
*
      ALF=ETA2
      CALL UXD$(LET)BF($N,$H,$IH,INF,ALF$ART
      NDECF=NDECF+1
      IDECF=3
      ELSE IF (IDECF.EQ.3) THEN
    $ENDIF
  $ELSEIF(HERF='S')
    $ADD(REAL,'\UXUDOT')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $N='NF'
    $ADD(REAL,'\$XS($NF)')
    $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$PSL($NF+1)\$PERM($NF)')
    $ADD(INTEGER,'\$WN11($NF+1)\$WN12($NF+1)')
    $IDECF=1
    IDECF=0
    INF=1
    ENDIF
    MM=$IH($N+1)-1
    TDXX(1:4)='G-M '
    IF (IDECF.EQ.0) THEN
    CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $30
    ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
    ALF=ETA2
    CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$XS,INF&
,ALF,BET)
    NDECF=NDECF+1
    IDECF=1
  $ENDIF
  ELSE
  ITERD=-1
  TDXX='BAD DEC$IDECF'
  CALL UOERR1('UD$(HERF)L$(DEC)2',1)
  GO TO $30
  ENDIF
  IF (NIT.LE.1) THEN
  JNITS=INITS
  JTERS=KTERS
  JRES1=IRES1
  MESS=MES
  EPS1S=EPS1
  EPS2S=EPS2
  ELSE
  INITS=JNITS
  KTERS=JTERS
  IRES1=JRES1
  MES=MESS
  EPS1=EPS1S
  EPS2=EPS2S
  ENDIF
  SNORM=GNORM
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
*
*     NEWTON LIKE STEP
*
  $IF(HERF='D')
    $IF(DEC='M')
      CALL UXVNEG($N,$GN,$SN)
      $IF(MOS2=0)
        CALL UXDPGB($N,$H,$SN,0)
      $ELSE
        CALL UXD$(LET)GB($N,$H,$IH,$SN,0)
      $ENDIF
      $H=HS
    $ELSEIF(DEC='G')
      CALL UXVNEG($N,$GN,$SN)
      CALL UXDPGB($N,$H,$SN,0)
    $ELSEIF(DEC='S')
      CALL UXVNEG($N,$GN,$SN)
      CALL UXD$(LET)GB($N,$H,$IH,$SN,0)
    $ELSEIF(DEC='B')
      CALL UXVNEG($N,$GN,$SN)
      $IF(MOS2<3)
        CALL UXDLBB($N,$H,$IH,$SN,0)
      $ELSE
        CALL UXDSBB($N,$H,$IH,$SN,0)
      $ENDIF
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXVNEG($N,$GN,$SN)
    CALL UXVSFP($N,$PERM,$SN,$XS)
    CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$SN,0)
    CALL UXVSBP($N,$PERM,$SN,$XS)
  $ENDIF
  INITD=MAX(ABS(INITD),1)
  ITERD=1
  $IF(DEC='M')
    IF (INF.NE.0) ITERD=2
  $ELSEIF(DEC='B')
    IF (INF.GT.0) THEN
    ITERD=4
    INITD=-INITD
    ENDIF
  $ENDIF
  IF(INF.EQ.0) THEN
  TDXX(5:8)=' POS'
  ELSEIF(INF.LT.0) THEN
  TDXX(5:8)=' ZER'
  ELSE IF (BET.LE.ETA3) THEN
  TDXX(5:8)=' NEG'
  ELSE IF (NIT.GT.KIT.AND.NIT.GT.1) THEN
  ALF=(GNORM/SNORM)**2/R
  CALL UXVDIR($N,-ALF,$XO,$GN,$SN)
  CALL UXVNEG($N,$SN,$SN)
  ITERD= 0
  INITS=-3
  KTERS= 4
  IRES1= 1
  MES=4
  TDXX='FLET RV '
  ELSE
  CALL UXVNEG($N,$GN,$SN)
  ITERD=0
  INITS=-3
  KTERS= 4
  IRES1= 1
  MES=4
  TDXX='ST DESC '
  ENDIF
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  NRED=INF
  CALL UOD1D5(ALF,BET,INF)
$30 CALL UOD1D2($N,$GN,$SN)
  IF (ITERD.EQ.0) THEN
  $IF(KDS=0)
    EPS1=4.0$P-1
  $ELSE
    EPS2=1.0$P-1
  $ENDIF
  ENDIF
  $ADD(INIT)
    NDXX='UD$(HERF)L$(DEC)2'
  $ENDADD
  $EXIT
