$INTERFACE UDSGV3                                             94/12/01
$REM LU
  $CON1='1.0$P-3'
  $CON2='0.85$P 0'
  $CON3='5.0$P-3'
  $CON4='0.5$P 0'
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    SWITCH FOR THE HYBRID METHOD:
      1 - THE FLETCHER AND XU SWITCH
      2 - THE DENNIS AND WELSCH SWITCH
      3 - THE RAMSIN AND WEDIN SWITCH
  $CHECK(MOT2,1,'1\2\3',3)
  $DEFAULT='0.4$P 0'
  $IF(MOS=1) $DEFAULT='0.2$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(REAL,'\$AG($MA)\$GN($NF)\$SN($NF)\$XO($NF)\$XS($NF)\$GO($NF)&
  \$GS($NF)\$AFO($NA)\$AFD($NA)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IX($NX)')
  $ADD(REAL,'\UXVDOT')
  $ADD(REAL,'\RHO\RHO1\RHO2\ALF\PPJ\PPB')
  $ADD(INTEGER,'\IPOM\JPOM')
  $ADD(LOGICAL,'\L1')
  $POM1='U'
  $POM2=',$$IX,KBF)'
  $ADD(REAL,'\UX$(POM1)DOT\UX$(POM1)DEL')
  $N='NF'
  CALL UOD1D1
  IF (NIT.LE.LIT+1) THEN
  IPOM=0
  JPOM=0
  PPJ=ZERO
  PPB=ZERO
  ELSE
  $IF(MOT2=2)
    RHO=R*R
    PPJ=PPJ*RHO
    PPB=PPB*RHO
  $ENDIF
  ENDIF
  IF (IDIR.EQ.0) THEN
*
*     DETERMINATION OF THE UPDATE VECTORS
*
  IPOM=0
  JPOM=0
  $IF(MOT2=3)
    L1=IPOM.EQ.1.OR.PPJ.LT.$CON3*FO.AND.PPJ.LT.$CON4*PPB
  $ELSEIF(MOT2=2)
    L1=.TRUE.
  $ELSE
    L1=FO-F.LE.ETA5*FO
  $ENDIF
  IF (L1) THEN
  RHO1=UXUDOT($N,$XO,$GO,$IX,KBF)
  IF (RHO1.LE.ZERO) GO TO $60
  CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$XO,$AFD)
  RHO2=UXVDOT(NA,$AFD,$AFD)
  IF (RHO2.LE.ZERO) GO TO $60
  RHO1=SQRT(RHO1)
  RHO2=SQRT(RHO2)
  CALL UXVSCL(NA,ONE/RHO2,$AFD,$AFD)
  CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AFD,$GS)
  CALL UXUDIR($N,-ONE/RHO1,$GO,$GS,$GS,$IX,KBF)
  CALL UXVNEG($N,$GS,$GS)
  $IF(MOT2=2)
    JPOM=1
    IF (PPB*PPJ.EQ.ZERO) GO TO $60
    IF (ABS((F-FO)/(PO+PPB)-ONE).LE.$CON2*ABS((F-FO)/(PO+PPJ)-ONE))&
    IPOM=1
  $ELSE
    IPOM=1
  $ENDIF
  ENDIF
  ENDIF
$60 GNORM=SQRT(UXUDOT($N,$GN,$GN,$IX,KBF))
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$GO,$AFO)
  RHO1=UXVDOT(NA,$AFO,$AFO)
  RHO2=GNORM*GNORM
  IF (RHO1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(RHO2/RHO1)*GNORM
  ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  SNORM=ZERO
  PAR=MIN(EPS6,SQRT(GNORM))
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**(DBLE(NIT-LIT)/DBLE($N)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVNEG($N,$GN,$XS)
  CALL UXVNEG($N,$GN,$XO)
  RHO1=UXUDOT($N,$XS,$XS,$IX,KBF)
  RHO=RHO1
  DO $10 NRED=1,$N+3
  IF (IPOM.EQ.0) THEN
  CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$XO,$AFO)
  ELSE
  ALF=UXUDOT($N,$GS,$XO,$IX,KBF)
  CALL UXSRMD($N,NA,MA,$AG,$IAG,$JAG,$XO,ALF,$AFD,$AFO)
  ENDIF
  ALF=UXVDOT(NA,$AFO,$AFO)
  TDXX='CG  MAX1'
  IF (ALF.LE.ZERO) GO TO $30
  ALF=RHO/ALF
  TDXX='CG  MAX2'
  RHO2=SQRT(UXUDEL($N,ALF,$XO,$SN,$IX,KBF))
  IF (RHO2.GE.XDEL) GO TO $30
*
*     CG STEP
*
  TDXX='CG  STEP'
  SNORM=RHO2
  CALL UXUDIR($N,ALF,$XO,$SN,$SN,$IX,KBF)
  IF (IPOM.EQ.0) THEN
  CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AFO,$GO)
  ELSE
  RHO2=UXVDOT(NA,$AFD,$AFO)
  CALL UXSCMD($N,NA,MA,$AG,$IAG,$JAG,$AFO,RHO2,$GS,$GO)
  ENDIF
  CALL UXUDIR($N,-ALF,$GO,$XS,$XS,$IX,KBF)
  RHO2=UXUDOT($N,$XS,$XS,$IX,KBF)
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  IF  (RHO2.LE.PAR*RHO1) GO TO $20
  ALF=RHO2/RHO
  CALL UXUDIR($N,ALF,$XO,$XS,$XO,$IX,KBF)
  RHO=RHO2
$10 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$20 CONTINUE
  SNORM=SQRT(UXUDOT($N,$SN,$SN,$IX,KBF))
  ITERD=2
  GO TO $40
*
*     BOUNDARY STEP IS COMPUTED
*
$30 CONTINUE
  RHO1=UXUDOT($N,$XO,$SN,$IX,KBF)
  RHO2=UXUDOT($N,$XO,$XO,$IX,KBF)
  CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,ALF)
  CALL UXUDIR($N,ALF,$XO,$SN,$SN,$IX,KBF)
  SNORM=XDEL
  ITERD=3
  NRED=-NRED
$40 CONTINUE
  RHO=PPJ
  CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$SN,$AFO)
  IF (IPOM.EQ.0.OR.MOT2.GE.2) THEN
  PPJ=UXVDOT(NA,$AFO,$AFO)*HALF
  PPB=ZERO
  ENDIF
  IF (IPOM.NE.0.OR.JPOM.NE.0) THEN
  ALF=UXUDOT($N,$GS,$SN,$IX,KBF)
  CALL UXVDIR(NA,ALF,$AFD,$AFO,$AFO)
  PPB=UXVDOT(NA,$AFO,$AFO)*HALF
  ENDIF
  IF (IPOM.EQ.0) THEN
  PP=PPJ
  ELSE
  PP=PPB
  ENDIF
  $IF(MOT2=3)
    PPB=RHO
  $ENDIF
$50 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UDSGV3'
  $ENDADD
  $EXIT
