$INTERFACE UDSLK5                                             03/12/01
$REM LU
  $CON1='1.0$P-3'
  $CON2='5.0$P-1'
  $CON4='1.0$P-8'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
  $POM1='U'
  $POM2=',$$IX,KBF)'
$REM  $HELP
$REM    MAXIMUM NUMBER OF DENSE COLUMNS:
$REM  $CHECK(MD,10,INT,2)
$REM  $HELP
$REM    MINIMUM NUMBER OF NONZERO ELEMENTS IN DENSE ROWS:
$REM  $CHECK(MDE,50,INT,2)
  $HELP
    MAXIMUM NUMBER OF CG ITERATIONS
  $CHECK(MCGR,0,INT,3,NO)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $IF(MEP=0) $MOS1=0
  $HELP
    TERMINATION, MATRIX CORRECTION AND
    CHOICE OF THE PENALTY PARAMETER
      0 - CLASSIC TERMINATION
      1 - DESCENT TERMINATION
      2 - EXTENDED CHOICE OF THE PENALTY PARAMETER
  $CHECK(MOS1,0,'0\1\2',4)
  $ADD(REAL,'\$CG($MC)\$CF($NC)\$G($NF)&
  \$S($NF+$NC)\$XO($NF+$NC)\$GO($NF+$NC)\$XS($NF+$NC)\$GS($NF+$NC)&
  \$XP($NF+$NC)\$GP($NF+$NC)\$CZ($NC)')
  $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)\$IX($NX)')
  $IF(MEP=1) $ADD(REAL,'\$CP($NC)')
  $ADD(REAL,'\UX$(POM1)DOT\UXVDOT\UXWDOT')
  $ADD(REAL,'\ALF\RHO\RHO1\RHO2\SIG\SIG1\SIG2\TAU\TET\PSI\TEMP\TEMP1&
  \TEMP2')
  $ADD(INTEGER,'\I\K\L\MM\MMX\IPOM\KPOM\NOS')
  $ADD(LOGICAL,'\L1')
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $IF(MEP=0)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P-4',REAL,3)
  $ELSEIF(MEP=1)
    $HELP
      PENALTY COEFFICIENT (IT MUST BE GREATER THEN ONE)
    $CHECK(RPF1,'1.5$P 0',REAL,3)
    $ADD(SINIT)
      CALL UXVSET($NN,ZERO,$CP)
    $ENDADD
  $ELSEIF(MEP=2)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.5$P 0',REAL,3)
  $ELSEIF(MEP=3)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.5$P-1',REAL,3)
  $ELSEIF(MEP=4)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
  $ELSEIF(MEP=5)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 2',REAL,3)
  $ENDIF
  $DEFAULT='0.9$P 0'
  $IF (MOS=1) $DEFAULT='0.1$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $DEFAULT='5.0$P-5'
  $IF(MEP=3) $DEFAULT='1.0$P-4'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  CALL UOD1D1
  $GRAD=G
  $IF(HERF='L')
    $ADD(INTEGER,'\MX')
    MX=MIN(NIT-KIT,MF)
  $ELSEIF(HERF='V')
    $GRAD=GN
    $SNS=SN
    $GAS=GA
    $XOS=XO
    $GCS=GC
    $GC=GG
    $ADD(REAL,'\$GC($NF)')
  $ENDIF
  IPOM=0
  RHO1=UX$(POM1)DOT($N,$G,$G$POM2
  SIG1=UXVDOT($NN,$CF,$CF)
*
*     SYSTEM TRANSFORMATION
*
  $FILE=XS
  $SUBST('UDSLKA')
*
*     CONSTRUCTION OF PRECONDITIONER
*
  $LKI=$90
  $SUBST('UDSLKI')
  MM=$N+$NN
  GNORM=SQRT(RHO1+SIG1)
  INITD=MAX(ABS(INITD),1)
  PAR=MIN(EPS6,GNORM)
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**($DBLE(NIT-LIT)/$DBLE(MM)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
*
*     QMR INITIATION
*
  CALL UXVSET(MM,ZERO,$S)
  CALL UXVSET(MM,ZERO,$XP)
  CALL UXVSET(MM,ZERO,$GP)
  CALL UXVCOP($N,$XS,$GS)
  CALL UXVNEG($NN,$CF,$GS($N+1))
  CALL UXVCOP(MM,$GS,$XO)
  $IF(NOS2=0)
    CALL UXVCOP(MM,$GS,$GO)
  $ENDIF
*
*     QMR PRECONDITIONING
*
  $INPF=GS
  $OUTF=GO
  $SUBST('UDSLKP')
  TET=ZERO
  TAU=RHO1+SIG1
  RHO=UX$(POM1)DOT($N,$XO,$GO$POM2+UXVDOT($NN,$XO($N+1),$GO($N+1))
  KPOM=0
  $IF(NOS2=1)
    $INDP=1
  $ELSEIF(NOS2=2)
    $INDP=1
  $ELSE
    $INDP=0
  $ENDIF
  MMX=MM+3
  $IF(MCGR>0)
    MMX=MIN(MMX,$MCGR)
  $ENDIF
*
*     QMR ITERATIONS
*
  DO $15 NRED=1,MMX
  $IF(HERF='D')
    CALL UXDSMM($N,$H,$GO,$XS)
  $ELSEIF(HERF='S')
    CALL UXSSMM($N,M,$H,$IH,$JH,$GO,$XS)
  $ELSEIF(HERF='L')
    $IF(CONSTR='C') CALL UX$(POM1)COP($N,$GO,$GO$POM2
    CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$GO,$XS,PAR3&
,$MET)
    $IF(UPDATE='E')
      CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$GO,$XS,PAR3&
,MET)
    $ELSE
      CALL UXLSMG($N,MX,$XM,$HR,$U1,$U3,$GO,$XS,PAR3,MET1)
    $ENDIF
  $ELSEIF(HERF='V')
    IF (IREST.NE.0) THEN
    CALL UXVCOP($N,$GO,$XS)
    GO TO $35
    ENDIF
    FO=F
    PP=SQRT(ETA0/UX$(POM1)DOT($N,$GO,$GO$POM2)
    $IF(MODP='FF')
      LD=MIN(KDF-1,0)
    $ELSE
      LD=MIN(KDA-1,0)
      $IF(MODEL='AF')
        LDA=LD
      $ELSE
        LDA=-1
      $ENDIF
      ISNAS=ISNA
      ISNA=0
    $ENDIF
    LDC=LD
    ISNCS=ISNC
    ISNC=0
    $SN=GO
    $XO=XV
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $30 TO IMD
    GO TO $LMD
$30 CONTINUE
    $IF(MODEL='AF')
      ISNA=ISNAS
    $ENDIF
    ISNC=ISNCS
    $XO=XOS
    $SN=SNS
    $GA=G
    $SUBST('UYTR$(CONSTR)A')
    CALL UXVDIF($N,$G,$GN,$XS)
    F=FO
    CALL UXVSCL($N,ONE/PP,$XS,$XS)
    $GA=GAS
$35 CONTINUE
  $ENDIF
  CALL UXSCMD($N,$NN,MC,$CG,$ICG,$JCG,$GO($N+1),ONE,$XS,$XS)
  CALL UXSRMM($N,$NN,MC,$CG,$ICG,$JCG,$GO,$XS($N+1))
  SIG=UX$(POM1)DOT($N,$GO,$XS$POM2+UXVDOT($NN,$GO($N+1),$XS($N+1))
  IF (SIG.EQ.ZERO) THEN
  ITERD=-4
  TDXX='QM BREAK'
  CALL UOERR1('UDSLK5',4)
  GO TO $90
  ENDIF
*
*     QMR STEP
*
  ALF=RHO/SIG
  CALL UX$(POM1)DIR($N,-ALF,$XS,$XO,$XO$POM2
  CALL UXVDIR($NN,-ALF,$XS($N+1),$XO($N+1),$XO($N+1))
  SIG=(UX$(POM1)DOT($N,$XO,$XO$POM2+UXVDOT($NN,$XO($N+1),$XO($N+1)))/TAU
  PSI=ONE/(ONE+SIG)
  TAU=TAU*SIG*PSI
  CALL UX$(POM1)LIN($N,PSI*TET,$XP,PSI*ALF,$GO,$XP$POM2
  CALL UXVLIN($NN,PSI*TET,$XP($N+1),PSI*ALF,$GO($N+1),$XP($N+1))
  CALL UX$(POM1)LIN($N,PSI*TET,$GP,PSI*ALF,$XS,$GP$POM2
  CALL UXVLIN($NN,PSI*TET,$GP($N+1),PSI*ALF,$XS($N+1),$GP($N+1))
  CALL UX$(POM1)DIR($N,ONE,$XP,$S,$S$POM2
  CALL UXVDIR($NN,ONE,$XP($N+1),$S($N+1),$S($N+1))
  CALL UX$(POM1)DIR($N,-ONE,$GP,$GS,$GS$POM2
  CALL UXVDIR($NN,-ONE,$GP($N+1),$GS($N+1),$GS($N+1))
  TET=SIG
  TDXX='QM STEP '
*
*     TERMINATION CRITERION
*
  L1=NRED.GE.MMX
  IF (L1) TDXX='MAX ITER'
  SIG2=UXVDOT($NN,$GS($N+1),$GS($N+1))
  IF (SIG2.LE.PAR*MAX(SIG1,$ETA0)) THEN
  $IF($DEF(RPF3))
    IF (RPF3.GT.ZERO) THEN
    CALL UXSCMD($N,$NN,MC,$CG,$ICG,$JCG,$GS($N+1),-ONE/RPF3,$GS,$XS)
    RHO2=UX$(POM1)DOT($N,$XS,$XS$POM2*RPF3**2
    ELSE
    RHO2=UX$(POM1)DOT($N,$GS,$GS$POM2
    ENDIF
  $ELSE
    RHO2=UX$(POM1)DOT($N,$GS,$GS$POM2
  $ENDIF
  IF (RHO2.LE.PAR*RHO1) L1=.TRUE.
  ENDIF
  IF (KOUT.GT.2) RHO2=UX$(POM1)DOT($N,$GS,$GS$POM2
*
*     TEST FOR DESCENT DIRECTION
*
  $LKT=$16
  $FILE=XS
  $SUBST('UDSLKT')
  IF (RHO.EQ.ZERO) THEN
  ITERD=-5
  TDXX='QM BREAK'
  CALL UOERR1('UDSLK5',5)
  GO TO $90
  ENDIF
*
*     QMR PRECONDITIONING
*
  $INPF=XO
  $IF(MOS2=0)
    $OUTF=XO
  $ELSE
    $OUTF=XS
  $ENDIF
  $SUBST('UDSLKP')
  ALF=ONE/RHO
  RHO=UX$(POM1)DOT($N,$XO,$OUTF$POM2+UXVDOT($NN,$XO($N+1),$OUTF($N+1))
  ALF=ALF*RHO
  CALL UX$(POM1)DIR($N,ALF,$GO,$OUTF,$GO$POM2
  CALL UXVDIR($NN,ALF,$GO($N+1),$OUTF($N+1),$GO($N+1))
$15 CONTINUE
  TDXX='MAX ITER'
  $IF(INDP=1)
    $IF(MOS1=2)
      $ADD(REAL,'\UXVNOR\UXUNOR')
      IF (IREST.EQ.0) THEN
      IF (UXVNOR($NN,$S($N+1)).LT.TEN*UX$(POM1)NOR($N,$S$POM2) THEN
      KPOM=1
      P=ZERO
      ENDIF
      ENDIF
    $ENDIF
  $ENDIF
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$16 CONTINUE
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
  $SUBST('UDSLKD')
$90 CONTINUE
  $IF(HERF='V')
    CALL UXVCOP(NF,$XV,$X)
    CALL UXVCOP(NF,$GN,$G)
    $GC=GCS
  $ENDIF
  CALL UOD1D2($N,$G,$S)
  $ADD(INIT)
    NDXX='UD$(HERF)LK5'
  $ENDADD
  $EXIT
