$INTERFACE UUBBM2                                             99/12/01
$REM LU
  $CON0='0.1$P 0'
  $CON2='4.0$P 0'
  $CON3='0.2$P 0'
  $CON6='0.5$P 0'
  $CON7='3.0$P 0'
  $HELP
    UPDATE OF THE HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP  UPDATE
      3 - HOSHINO UPDATE
      4 - RANK ONE UPDATE
  $CHECK(MET,1,'1\2\3\4',3)
  $HELP
    SELECTION OF SELF SCALING:
      1 - SELF SCALING SUPPRESSED
      2 - INITIAL SELF SCALING
      3 - CONTROLLED SELF SCALING
      4 - INTERVAL SELF SCALING
      5 - SELF SCALING IN EACH ITERATION
  $CHECK(MET1,1,'1\2\3\4\5',4)
  $HELP
    METHOD CORRECTION:
      1 - NO CORRECTION
      2 - POWELL'S CORRECTION
      3 - INDEFINITE UPDATE ALLOWED
  $CHECK(MET3,1,'1\2\3',4)
  $ADD(REAL,'\$AH($MAH)\$S($NF)\$XO($NF)\$AGO($MA)')
$REM  $ADD(REAL,'\PAR1\PAR2')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\NAL\MA\MAH')
  $POM1='NF,NA,NAL,MA,MAH,$AH,$IAG,$JAG,$S,$XO,$AGO'
  $POM2='NF,NA,NAL,MA,MB,AH,IAG,JAG,S,XO,AGO'
  $IF(MET1=3)
    $ADD(POM1,',PAR1,PAR2')
    $ADD(POM2,',PAR1,PAR2')
  $ENDIF
  $IF(MET=4)
    $ADD(POM1,',$ETA0')
    $ADD(POM2,',ETA0')
  $ENDIF
  $ADD(POM1,',$ETA9')
  $ADD(POM2,',ETA9')
  $ADD(POM1,',$MET,$MET1')
  $ADD(POM2,',MET,MET1')
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUBBM2$(NUMSUB)($POM1)
  $ADD(SUBROUTINES)
*     -----------------------------------
*     PARTITIONED VARIABLE METRIC UPDATES
*     TEMPLATE : UUBBM2
*     -----------------------------------
  SUBROUTINE UUBBM2$(NUMSUB)($POM2)
  $INCLUDE('UMCOMM')
  INTEGER NF,NA,NAL,MA,MB,IAG(NA+1),JAG(MA),MET,MET1
  $$FLOAT AH(MB),S(NF),XO(NF),AGO(MA)
  $$IF($MET=4) $$FLOAT ETA0
  $$IF($MET>1) $$FLOAT DEN
  $$IF($MET=2)
    $$FLOAT DIS
  $$ELSEIF($MET=3)
    $$FLOAT DIS
  $$ELSEIF($MET3=2)
    $$FLOAT DIS
  $$ENDIF
  $$IF($MET1=3) $$FLOAT PAR1,PAR2
  $$FLOAT ETA9
  $$FLOAT UXWDOT
  $$FLOAT A,B,C,GAM,POM
  INTEGER K,L,KA,NB
  LOGICAL L1,L3
  $$IF($MET1=3) LOGICAL L2
  IF (MET.LE.0) GO TO 22
  IF(IDECF.NE.0) THEN
  ITERH=-1
  TUXX='BAD DEC0'
  CALL UOERR1('UUBBM2',1)
  GO TO 22
  ENDIF
  L1=MET1.GE.3.OR.MET1.EQ.2.AND.NIT.EQ.KIT
  L3=.NOT.L1
  TUXX='        '
  NB=0
  DO 21 KA=1,NA
  K=IAG(KA)
  L=IAG(KA+1)-K
  IF (KA.LE.NAL) GO TO 20
*
*     DETERMINATION OF THE PARAMETERS B, C
*
  B=UXWDOT(L,NF,JAG(K),AGO(K),XO,2)
  $$IF($MET3=1)
    IF (B.LE.ONE/ETA9) GO TO 20
  $$ELSEIF($MET3=3)
    IF (ABS(B).LE.ONE/ETA9) GO TO 20
  $$ENDIF
  A=ZERO
  CALL UXBSBM(L,NF,AH(NB+1),JAG(K),XO,S,1)
  C=UXWDOT(L,NF,JAG(K),XO,S,1)
  $$IF($MET3=3)
    IF (ABS(C).LE.ONE/ETA9) GO TO 20
  $$ELSE
    IF (C.LE.ONE/ETA9) GO TO 20
  $$ENDIF
  $$IF($MET3=2)
    IF(B.LE.ZERO) THEN
*
*     POWELL'S CORRECTION
*
    DIS=(ONE-$CON0)*C/(C-B)
    CALL UXWDIR(L,NF,JAG(K),-ONE,AGO(K),S,AGO(K),2)
    CALL UXWDIR(L,NF,JAG(K),-DIS,AGO(K),S,AGO(K),2)
    B=C+DIS*(B-C)
    ENDIF
  $$ENDIF
  IF (L1) THEN
*
*     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
*
  GAM=C/B
  $$IF($MET1=3)
    IF (NIT.NE.KIT) THEN
    L2=PAR2.LE.ZERO
    L3=L2.AND.ABS(PAR1).LE.$CON3
    L3=L3.OR.(.NOT.L2.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.GAM.LT.ONE)
    L3=L3.OR.GAM.LT.$CON6
    L3=L3.OR.GAM.GT.$CON7
    ENDIF
  $$ELSEIF($MET1=4)
    IF (NIT.NE.KIT) THEN
    L3=GAM.LT.$CON6.OR.GAM.GT.$CON2
    ENDIF
  $$ELSEIF($MET1=5)
    GAM=MAX(ONE,GAM)
  $$ENDIF
  IF (L3) THEN
  GAM=ONE
  ENDIF
  ELSE
  GAM=ONE
  ENDIF
  $$U17=0
  $$IF($MET=1)
    $$U17=1
    NUPD=NUPD+1
  $$ELSEIF($MET=2)
*
*     DFP UPDATE
*
    DEN=GAM*B+C
    DIS=GAM+C/B
    POM=ONE
    CALL UXWDIR(L,NF,JAG(K),-DIS,AGO(K),S,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),ONE/DEN,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),-ONE/DEN,S,1)
    IF (TUXX.EQ.'        ') TUXX='DFP     '
    NUPD=NUPD+1
  $$ELSEIF($MET=3)
*
*     HOSHINO UPDATE
*
    DEN=GAM*B+C
    DIS=HALF*B
    POM=GAM*B/DEN
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),GAM/DIS,AGO(K),2)
    CALL UXWDIR(L,NF,JAG(K),GAM,AGO(K),S,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),-ONE/DEN,AGO(K),2)
    IF (TUXX.EQ.'        ') TUXX='HOSHINO '
    NUPD=NUPD+1
  $$ELSEIF($MET=4)
    $$U17=1
*
*    RANK ONE UPDATE
*
    DEN=GAM*B-C
    $$IF($MET3=3)
      IF (ABS(DEN).GT.ETA0*ABS(C)) THEN
    $$ELSE
      IF (DEN.GT.ETA0*C) THEN
    $$ENDIF
    POM=GAM*B/DEN
    CALL UXWDIR(L,NF,JAG(K),-GAM,AGO(K),S,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K), ONE/DEN,AGO(K),2)
    IF (TUXX.EQ.'        ') TUXX='RANK ONE'
    NUPD=NUPD+1
    GO TO 19
    ENDIF
  $$ENDIF
  $$IF(U17>0)
*
*     BFGS UPDATE
*
    POM=ZERO
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),GAM/B,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),-ONE/C,S,1)
    IF (TUXX.EQ.'        ') TUXX='BFGS    '
  $$ENDIF
19 CONTINUE
  ITERH=0
  IF (GAM.NE.ONE) THEN
    CALL UXDSMS(L,AH(NB+1),ONE/GAM)
    NSCL=NSCL+1
  ENDIF
20 CONTINUE
  NB=NB+L*(L+1)/2
21 CONTINUE
  IF (TUXX.EQ.'        ') TUXX='NONE UP.'
22 CONTINUE
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUBBM2'
  $ENDADD
  $EXIT
