$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZPROB                                    01/12/92  +
$REM + LU                                                            +
$REM + PURPOSE:  SPECIFICATION OF PROBLEM                            +
$REM +---------------------------------------------------------------+

$IF($DEF(MODELF)=.FALSE.) $MODELF='NO'
$IF($DEF(MODELA)=.FALSE.) $MODELA='NO'
$IF($DEF(MODELC)=.FALSE.) $MODELC='NO'
$IF($DEF(MODELE)=.FALSE.) $MODELE='NO'
$IF($DEF(MODELY)=.FALSE.) $MODELY='NO'
$IF($DEF(FMODELF))
  $HELP
    TYPE OF OBJECTIVE FUNCTION
      FF - GENERAL FUNCTION
      DF - DIFFERENTIAL SYSTEM WITH INTEGRAL CRITERION
      DQ - DIFERRENTIAL SYSTEM WITH INTEGRAL OF SQUARES
  $CHECK(MODEL,'FF','FF\DF\DQ',1,NO)
$ELSEIF($DEF(FGMODELF))
  $HELP
    TYPE OF OBJECTIVE FUNCTION
      FF - GENERAL FUNCTION
      DF - DIFFERENTIAL SYSTEM WITH INTEGRAL CRITERION
      DQ - DIFERRENTIAL SYSTEM WITH INTEGRAL OF SQUARES
  $CHECK(MODEL,'FF','FF\DF\DQ',1,NO)
$ELSEIF($DEF(FGDMODELF))
  $HELP
    TYPE OF OBJECTIVE FUNCTION
      FF - GENERAL FUNCTION
      DF - DIFFERENTIAL SYSTEM WITH INTEGRAL CRITERION
      DQ - DIFERRENTIAL SYSTEM WITH INTEGRAL OF SQUARES
  $CHECK(MODEL,'FF','FF\DF\DQ',1,NO)
$ELSEIF($DEF(FGHMODELF))
  $HELP
    TYPE OF OBJECTIVE FUNCTION
      FF - GENERAL FUNCTION
      DF - DIFFERENTIAL SYSTEM WITH INTEGRAL CRITERION
      DQ - DIFERRENTIAL SYSTEM WITH INTEGRAL OF SQUARES
  $CHECK(MODEL,'FF','FF\DF\DQ',1,NO)
$ELSEIF($DEF(FMODELA))
  $HELP
    TYPE OF OBJECTIVE FUNCTION
      AF - SUM OF FUNCTIONS
      AQ - SUM OF SQUARES
      AP - SUM OF POWERS
      AA - SUM OF ABSOLUTE VALUES
      AM - MINIMAX
      DF - DIFFERENTIAL SYSTEM WITH INTEGRAL CRITERION
      DQ - DIFERRENTIAL SYSTEM WITH INTEGRAL OF SQUARES
      NE - NONLINEAR EQUATIONS
  $CHECK(MODEL,'AF','AF\AQ\AP\AA\AM\DF\DQ\NE',1,NO)
$ELSEIF($DEF(FGMODELA))
  $HELP
    TYPE OF OBJECTIVE FUNCTION
      AF - SUM OF FUNCTIONS
      AQ - SUM OF SQUARES
      AP - SUM OF POWERS
      AA - SUM OF ABSOLUTE VALUES
      AM - MINIMAX
      DF - DIFFERENTIAL SYSTEM WITH INTEGRAL CRITERION
      DQ - DIFERRENTIAL SYSTEM WITH INTEGRAL OF SQUARES
      NE - NONLINEAR EQUATIONS
  $CHECK(MODEL,'AF','AF\AQ\AP\AA\AM\DF\DQ\NE',1,NO)
$ELSEIF($DEF(FGDMODELA))
  $HELP
    TYPE OF OBJECTIVE FUNCTION
      AF - SUM OF FUNCTIONS
      AQ - SUM OF SQUARES
      AP - SUM OF POWERS
      AA - SUM OF ABSOLUTE VALUES
      AM - MINIMAX
      DF - DIFFERENTIAL SYSTEM WITH INTEGRAL CRITERION
      DQ - DIFERRENTIAL SYSTEM WITH INTEGRAL OF SQUARES
  $CHECK(MODEL,'AF','AF\AQ\AP\AA\AM\DF\DQ',1,NO)
$ELSEIF($DEF(FGHMODELA))
  $HELP
    TYPE OF OBJECTIVE FUNCTION
      AF - SUM OF FUNCTIONS
      AQ - SUM OF SQUARES
      AP - SUM OF POWERS
      AA - SUM OF ABSOLUTE VALUES
      AM - MINIMAX
      DF - DIFFERENTIAL SYSTEM WITH INTEGRAL CRITERION
      DQ - DIFERRENTIAL SYSTEM WITH INTEGRAL OF SQUARES
  $CHECK(MODEL,'AF','AF\AQ\AP\AA\AM\DF\DQ',1,NO)
$ELSE
  $HELP
    TYPE OF OBJECTIVE FUNCTION
      FF - GENERAL FUNCTION
      FL - LINEAR FUNCTION
      FQ - QUADRATIC FUNCTION
      AF - SUM OF FUNCTIONS
      AQ - SUM OF SQUARES
      AP - SUM OF POWERS
      AA - SUM OF ABSOLUTE VALUES
      AM - MINIMAX
      DF - DIFFERENTIAL SYSTEM WITH INTEGRAL CRITERION
      DQ - DIFERRENTIAL SYSTEM WITH INTEGRAL OF SQUARES
      DE - DIFFERENTIAL EQUATIONS
      NE - NONLINEAR EQUATIONS
      NO - MODEL IS NOT SPECIFIED
  $CHECK(MODEL,'FF','FF\FL\FQ\AF\AQ\AP\AA\AM\DF\DQ\DE\NE\NO\N',1,NO)
  $IF(MODEL='N') $MODEL='NO'
$ENDIF
$IF(MODEL='DE')
  $MODEL='NO'
$ENDIF
$EQUATIONS=0
$IF(MODEL='NE')
  $MODEL='AQ'
  $EQUATIONS=1
  $HELP
    TYPE OF A PARTIAL FUNCTION MODEL:
      N - STANDARD MODEL
      Y - REDUCED MODEL
  $CHECK(ARED,'N','NO\N\YES\Y',1,NO)
  $IF(ARED='N') $ARED='NO'
  $IF(ARED='Y') $ARED='YES'
$ENDIF
$IF(MODEL='NO') $HESF='NO'

$ISNF=1
$IF(MODEL<>'NO')
  $REPEAT
    $HELP
      NUMBER OF VARIABLES
    $CHECK(NF,0,INT,1)
    $IF(NF<=0)
      $IF(DIALOG>0)
        $ERASE(NF)
      $ELSE
        $ERROR 'NF' - NUMBER OF VARIABLES WAS NOT SPECIFIED
        $STOP
      $ENDIF
    $ENDIF
  $UNTIL($DEF(NF))
$ENDIF

$IF(MODEL='F?')
  $NE=0
  $NA=0
  $NAL=0
  $ISNA=0
  $NORMA=0
  $HELP
    TYPE OF EXTREMUM
      0 - MINIMUM
      1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $IF(MODEL='FF')
    $IF(IEXT=0)
      $H=HF
    $ENDIF
    $SUBST('UZMODF')
    $HELP
      COMPLEXITY OF THE OBJECTIVE FUNCTION
        1 - EASY COMPUTED FUNCTION
        2 - REASONABLE BUT NOT EASY COMPUTED FUNCTION
        3 - EXTREMELY COMPLICATED FUNCTION
    $CHECK(KCF,2,'1\2\3',1)
    $HELP
      SMOOTHNESS OF THE OBJECTIVE FUNCTION:
        1 - SMOOTH AND WELL-CONDITIONED FUNCTION
        2 - SMOOTH BUT ILL-CONDITIONED FUNCTION
        3 - NONSMOOTH FUNCTION
    $CHECK(KSF,1,'1\2\3',1)
    $HELP
      TYPE OF HESSIAN MATRIX:
        D - DENSE
        S - SPARSE WITH KNOWN (GENERAL) STRUCTURE
        N - HESSIAN MATRIX IN NOT USED
    $CHECK(HESF,'D','D\S\NO\N',1,NO)
    $IF(HESF='N') $HESF='NO'
  $ELSEIF(MODEL='FL')
    $HESF='NO'
    $KDF=1
  $ELSEIF(MODEL='FQ')
    $KDF=2
    $HELP
      TYPE OF HESSIAN MATRIX:
        D - DENSE
        S - SPARSE WITH KNOWN (GENERAL) STRUCTURE
    $CHECK(HESF,'D','D\S',1,NO)
  $ENDIF
  $IF(HESF='D')
    $M='$NF*($NF+1)/2'
$REM    $ADD(SUBID)
$REM      M=NF*(NF+1)/2
$REM    $ENDADD
  $ELSEIF(HESF='S')
    $IF(MODEL='FL')
      $MODEL='LF'
    $ENDIF
    $IF(MODEL='F?')
      $HELP
        LENGTH OF WORK SPACE FOR HESSIAN IN
        SPARSE DIRECT METHODS
      $CHECK(M,'20*$NF',INT,1)
    $ENDIF
    $IF(MODEL='LF')
      $MODEL='FL'
    $ENDIF
  $ENDIF
$ELSEIF(MODEL='A?')
  $NE=0
  $IF(MODEL='AP')
    $HELP
      EXPONENT IN SUM OF SQUARES
    $CHECK(REXP,'2.0$P 0',REAL,1)
    $IF(REXP='2.0$P 0') $MODEL='AQ'
  $ENDIF
  $IF(MODEL='AM')
    $HELP
      TYPE OF EXTREMUM:
         0 - CHEBYSHEV APPROXIMATION
        -1 - MINIMAX
         1 - MAXIMIN
    $CHECK(IEXT,0,'-1\0\1',1)
  $ENDIF
  $HELP
    TYPE OF DEVIATIONS
      0 - DEVIATION WITH THE INDEX KA IS FA
      1 - DEVIATION WITH THE INDEX KA IS FA-AM(KA)
  $CHECK(KBA,'0','0\1',1)
  $IF(KBA=0) $AM=AF
  $REPEAT
    $HELP
      NUMBER OF APPROXIMATED FUNCTIONS
    $CHECK(NA,0,INT,1)
    $IF(NA<=0)
      $IF(DIALOG>0)
        $ERASE(NA)
      $ELSE
        $ERROR: 'NA' - NUMBER OF APPROXIMATED FUNCTIONS WAS NOT SPECIFIED
        $STOP
      $ENDIF
    $ENDIF
  $UNTIL($DEF(NA))
  $HELP
    NUMBER OF LINEAR FUNCTIONS
  $CHECK(NAL,0,INT,1)
  $IF(NA>NAL)
    $SUBST('UZMODA')
    $HELP
      COMPLEXITY OF PARTIAL FUNCTIONS:
        1 - EASY COMPUTED FUNCTIONS
        2 - REASONABLE BUT NOT EASY COMPUTED FUNCTIONS
        3 - EXTREMELY COMPLICATED FUNCTIONS
    $CHECK(KCA,2,'1\2\3',1)
    $HELP
      SMOOTHNESS OF PARTIAL FUNCTIONS:
        1 - SMOOTH AND WELL-CONDITIONED FUNCTIONS
        2 - SMOOTH BUT ILL-CONDITIONED FUNCTIONS
        3 - NONSMOOTH FUNCTIONS
    $CHECK(KSA,1,'1\2\3',2)
  $ELSE
    $NA=NAL
  $ENDIF
  $IF(NAL>0)
    $IF($DEF(ISNA)=.FALSE.) $ISNA=1
    $IF(ISNA<1) $ISNA=1
    $ADD(INIT)
      ISNA=$ISNA
    $ENDADD
  $ELSEIF($DEF(ISNA)=.FALSE.)
    $HELP
      PRINT OF VALUES OF THE APPROXIMATED FUNCTIONS
        0 - PRINT IS SUPPRESSED
        1 - PRINT IS ACCEPTED
    $CHECK(ISNA,1,'0\1',1)
  $ENDIF
  $IF(KBA<>0)
    $SUBST('UAINT1')
    $HELP
      SCALING SPECIFICATION FOR PARTIAL FUNCTIONS:
        0 - NO SCALING IS PERFORMED
        1 - SCALING FACTORS ARE DETERMINED AUTOMATICALLY
        2 - SCALING GIVEN BY THE USER
    $CHECK(NORMA,0,'0\1\2',1)
  $ELSE
    $NORMA=0
    $ADD(INIT)
      NORMA=$NORMA
    $ENDADD
  $ENDIF
$REM  $IF(NA=NF)
  $HELP
    TYPE OF JACOBIAN MATRIX FOR APPROXIMATED FUNCTIONS
      D - DENSE
      S - SPARSE WITH KNOWN (GENERAL) STRUCTURE
      N - JACOBIAN MATRIX IN NOT USED
  $CHECK(JACA,'D','D\S\NO\N',1,NO)
  $IF(JACA='N') $JACA='NO'
$REM  $ELSE
$REM    $HELP
$REM      TYPE OF JACOBIAN MATRIX FOR APPROXIMATED FUNCTIONS
$REM        D  - DENSE
$REM        S  - SPARSE WITH KNOWN (GENERAL) STRUCTURE
$REM    $CHECK(JACA,'D','D\S',1,NO)
$REM  $ENDIF
  $IF(JACA='N')
    $HELP
      TYPE OF A PARTIAL FUNCTION MODEL:
        N - STANDARD MODEL
        Y - REDUCED MODEL
    $CHECK(ARED,'N','NO\N\YES\Y',1,NO)
    $IF(ARED='N') $ARED='NO'
    $IF(ARED='Y') $ARED='YES'
  $ELSEIF(JACA='S')
    $HELP
      TYPE OF A PARTIAL FUNCTION MODEL:
        N - STANDARD MODEL
        Y - REDUCED MODEL
    $CHECK(ARED,'N','NO\N\YES\Y',1,NO)
    $IF(ARED='N') $ARED='NO'
    $IF(ARED='Y') $ARED='YES'
    $HELP
      NUMBER OF NONZERO ELEMENTS IN THE
      SPARSE JACOBIAN MATRIX
    $CHECK(MA,'10*$NA',INT,1)
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
    $HELP
      TYPE OF HESSIAN MATRIX:
        D - DENSE
        B - SPARSE WITH KNOWN (PARTITIONED) STRUCTURE
        S - SPARSE WITH KNOWN (GENERAL) STRUCTURE
        N - HESSIAN MATRIX IN NOT USED
    $CHECK(HESF,'S','D\B\S\NO\N',1,NO)
    $IF(HESF='N') $HESF='NO'
    $IF(HESF='NO')
      $HELP
        LENGTH OF THE JACOBIAN MATRIX IN VECTOR FORM
      $CHECK(M,MA,INT,1)
    $ENDIF
$REM    $IF(KDA>=2)
$REM      $HELP
$REM        MAXIMUM NUMBER OF NONZERO ELEMENTS IN THE
$REM        APPROXIMATED FUNCTION HESSIAN MATRIX
$REM      $CHECK(ME,55,INT,1)
$REM    $ENDIF
  $ELSE
    $ARED='NO'
    $MA='$NF*$NA'
    $DEFAULT='D'
    $HELP
      TYPE OF HESSIAN MATRIX:
        D - DENSE
        N - HESSIAN MATRIX IN NOT USED
    $CHECK(HESF,DEFAULT,'D\NO\N',1,NO)
    $IF(HESF='N') $HESF='NO'
  $ENDIF
  $IF(HESF='NO')
  $ELSEIF(HESF='D')
    $M='$NF*($NF+1)/2'
$REM    $ADD(SUBID)
$REM      M=NF*(NF+1)/2
$REM    $ENDADD
  $ELSE
    $HELP
      LENGTH OF THE HESSIAN MATRIX IN VECTOR FORM
    $CHECK(M,'20*$NF',INT,1)
  $ENDIF
  $GF='G'
  $HF='H'
$ELSEIF(MODEL='D?')
  $ARED='NO'
  $NAL=0
  $ISNA=0
  $NORMA=0
  $IF(MODEL<>'DQ') $KBA=0
  $HELP
    TYPE OF DEVIATIONS
      0 - DEVIATION WITH THE INDEX KA IS FA
      1 - DEVIATION WITH THE INDEX KA IS FA-AM(KA)
  $CHECK(KBA,'0','0\1',1)
  $HELP
    TYPE OF HESSIAN MATRIX:
      D - DENSE
      N - HESSIAN MATRIX IN NOT USED
  $CHECK(HESF,'D','D\NO\N',1,NO)
  $IF(HESF='N') $HESF='NO'
  $IF(HESF='D')
    $M='$NF*($NF+1)/2'
$REM    $ADD(SUBID)
$REM      M=NF*(NF+1)/2
$REM    $ENDADD
  $ENDIF
  $HELP
    NUMBER OF DIFFERENTIAL EQUATIONS
  $CHECK(NE,0,INT,1)
  $SUBST('UZMODF')
  $SUBST('UZMODA')
  $SUBST('UZMODE')
  $SUBST('UZMODY')
$ENDIF
$IF($DEF(IEXT))
$ELSE
  $IEXT=0
$ENDIF

$CONSTR='U'
$IF($DEF(NF))
  $IF($DEF(NX))
  $ELSEIF($DEF(NCB))
    $NX=NCB
  $ENDIF
  $HELP
    NUMBER OF BOX CONSTRAINTS
  $CHECK(NX,0,INT,1,NO)
  $IF(NX< 0) $NX=NF
  $IF(NX>NF) $NX=NF
  $IF(NX>0)
    $HELP
      TYPE OF SIMPLE BOUNDS:
        1 - ONE SIDED SIMPLE BOUNDS
        2 - TWO SIDED SIMPLE BOUNDS
    $CHECK(KBF,'2','1\2',1)
  $ELSE
    $HELP
      TYPE OF SIMPLE BOUNDS:
        0 - NO SIMPLE BOUNDS
        1 - ONE SIDED SIMPLE BOUNDS
        2 - TWO SIDED SIMPLE BOUNDS
    $CHECK(KBF,'0','0\1\2',1)
    $IF(KBF=0)
      $NX=0
    $ELSE
      $NX=NF
    $ENDIF
  $ENDIF
  $IF(NX=0)
    $NX=1
  $ENDIF
  $ADD(INIT)
    NX=$NX
  $ENDADD
  $ADD(SUBID)
    NX=MIN(NF,$NX)
  $ENDADD
  $IF(KBF>0)
    $CONSTR='S'
    $ADD(SUBIT)
      $SUBST('UCSET1')
    $ENDADD
    $ADD(SUBID)
      $SUBST('UCSET3')
    $ENDADD
  $ENDIF
$ELSE
  $KBF=0
  $NCB=0
  $NX=1
$ENDIF
$IF($DEF(NF)) $NX=NF
$CON='S'

$HELP
  NUMBER OF GENERAL CONSTRAINTS
$CHECK(NC,0,INT,1)
$HELP
  NUMBER OF COMPLEMENTARITY CONSTRAINTS
$CHECK(NCC,0,INT,1)
$IF(NC>0)
  $HELP
    TYPE OF GENERAL CONSTRAINTS:
      1 - ONE SIDED GENERAL CONSTRAINTS
      2 - TWO SIDED GENERAL CONSTRAINTS
  $CHECK(KBC,'2','1\2',1)
$ELSE
  $NCE=0
  $KBC=0
$ENDIF
$IF(KBC=0)
  $NC=0
  $NCL=0
  $ISNC=0
  $NORMC=0
  $JACC='N'
$ELSE
  $HELP
    NUMBER OF EQUALITY CONSTRAINTS
  $CHECK(NCE,0,INT,1,NO)
  $SN='SN'
  $HELP
    NUMBER OF LINEAR CONSTRAINTS
  $CHECK(NCL,0,INT,1)
  $IF(NC>NCL)
    $SUBST('UZMODC')
    $HELP
      COMPLEXITY OF CONSTRAINT FUNCTIONS:
        1 - EASY COMPUTED FUNCTIONS
        2 - REASONABLE BUT NOT EASY COMPUTED FUNCTIONS
        3 - EXTREMELY COMPLICATED FUNCTIONS
    $CHECK(KCC,2,'1\2\3',1)
    $HELP
      SMOOTHNESS OF CONSTRAINT FUNCTIONS:
        1 - SMOOTH AND WELL-CONDITIONED FUNCTIONS
        2 - SMOOTH BUT ILL-CONDITIONED FUNCTIONS
        3 - NONSMOOTH FUNCTIONS
    $CHECK(KSC,1,'1\2\3',2)
  $ELSE
    $NC=NCL
  $ENDIF
  $IF(NCL>0)
    $IF($DEF(ISNC)=.FALSE.) $ISNC=1
    $ADD(INIT)
      ISNC=$ISNC
    $ENDADD
  $ELSEIF($DEF(ISNC)=.FALSE.)
    $HELP
      PRINT OF VALUES OF THE CONSTRAINT FUNCTIONS
        0 - PRINT IS SUPPRESSED
        1 - PRINT IS ACCEPTED
    $CHECK(ISNC,1,'0\1',1)
  $ENDIF
  $IF(.FALSE.)
    $HELP
      SCALING SPECIFICATION FOR CONSTRAINTS:
        0 - NO SCALING IS PERFORMED
        1 - SCALING FACTORS ARE DETERMINED AUTOMATICALLY
    $CHECK(NORMC,0,'0\1',1)
  $ELSE
    $NORMC=0
    $ADD(INIT)
      NORMC=$NORMC
    $ENDADD
  $ENDIF
  $HELP
    TYPE OF JACOBIAN MATRIX FOR CONSTRAINTS
      D - DENSE
      S - SPARSE WITH KNOWN (GENERAL) STRUCTURE
  $CHECK(JACC,'D','D\S',1,NO)
  $IF(JACC='D')
    $CRED='NO'
    $MC='$NF*$NC'
    $IF(NC=NCL)
      $CONSTR='B'
    $ENDIF
    $IF(HESF='S')
      $ERROR: SPARSE HESSIAN MATRIX CANNOT BE USED
              FOR OPTIMIZATION WITH DENSE CONSTRAINS
      $STOP
    $ENDIF
    $IF(HESF='B')
      $ERROR: PARTITIONED HESSIAN MATRIX CANNOT BE USED
              FOR OPTIMIZATION WITH DENSE CONSTRAINS
      $STOP
    $ENDIF
  $ELSE
    $HELP
      TYPE OF A CONSTRAINT FUNCTION MODEL:
        N - STANDARD MODEL
        Y - REDUCED MODEL
    $CHECK(CRED,'N','NO\N\YES\Y',1,NO)
    $IF(CRED='N') $CRED='NO'
    $IF(CRED='Y') $CRED='YES'
    $IF(MODEL='FL') $HESF='NO'
    $HELP
      NUMBER OF NONZERO ELEMENTS IN THE
      SPARSE JACOBIAN MATRIX
    $CHECK(MC,'10*$NC',INT,1)
    $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)')
    $DEFAULT='2*($NF+$NC)+1'
    $HELP
      MAXIMUM NUMBER OF VARIABLES AFTER TRANSFORMATION
      IT MUST BE EQUAL AT LEAST TO:
        NUMBER OF VARIABLES + 1 +
        NUMBER OF LOWER OR UPPER BOUNDED CONSTRAINTS +
        TWICE THE NUMBER OF CONSTRAINTS WITH BOTH BOUNDS +
        SOME ADDITIONAL SPACE FOR ARTIFICIAL VARIABLES.
          THIS ADDITIONAL SPACE IS LESS OR EQUAL
          TO THE NUMBER OF VARIABLES.
          IN PRACTICE IT IS EQUAL TO SOME SMALL INTEGER DEPENDING
          ON SPARSITY OF MATRIX OF CONSTRAINTS.
      OUR DEFAULT USUALLY OVERESTIMATES NECESSARY SPACE.
    $CHECK(MCOLS,DEFAULT,STR,1)
    $DEFAULT='2*($NC)+1'
    $HELP
      MAXIMUM NUMBER OF CONSTRAINTS AFTER THEIR
      TRANSFORMATION - NOT LESS THAN NC,NCL
      IT MUST BE EQUAL AT LEAST TO :
        NUMBER OF CONSTRAINTS +
        NUMBER OF CONSTRAINTS WITH BOTH BOUNDS + 1.
      OUR DEFAULT USUALLY OVERESTIMATES THIS SIZE
    $CHECK(MROWS,DEFAULT,STR,1)
    $DEFAULT='6*($NF+$NC)'
    $HELP
      LENGTH OF ARRAYS FOR THE INPUT NONZEROS
          OF THE MATRIX OF CONSTRAINTS
    $CHECK(NZA,DEFAULT,INT,1)
    $HELP
      LENGTH OF ARRAY FOR THE STRUCTURAL INFORMATION
          ON NONZEROS OF SPARSE BASIS
    $CHECK(NZ,DEFAULT,INT,1)
    $HELP
      LENGTH OF ARRAY FOR THE NUMERICAL ELEMENTS OF SPARSE BASIS
    $CHECK(NAU,DEFAULT,INT,1)
    $DEFAULT='4*($MCOLS)'
    $HELP
      MAXIMUM NUMBER OF EXPLICITLY STORED L-UPDATES - USUAL
      LENGTH IS 4*MCOLS OR MORE
    $CHECK(NUP,DEFAULT,INT,1)
  $ENDIF
  $ADD(SUBIT)
    $SUBST('UCSET2')
  $ENDADD
  $ADD(SUBID)
    $SUBST('UCSET4')
  $ENDADD
  $ADD(REAL,'\$CL($NC)')
  $IF(KBC=2) $ADD(REAL,'\$CU($NC)')
$ENDIF
$REM $IF(JACC='D')
$IF(.TRUE.)
  $IF(KBF=0)
    $XL='X'
    $XU='X'
  $ENDIF
  $IF(KBF=1)
    $XU='XL'
  $ENDIF
  $IF(KBC=1)
    $CU='CL'
  $ENDIF
$ELSE
  $IF(KBC=0)
    $IF(KBF=0)
      $XL='X'
      $XU='X'
    $ENDIF
    $IF(KBF=1)
      $XU='XL'
    $ENDIF
  $ENDIF
$ENDIF

$IF($DEF(ARED))
  $IF(ARED='YES')
    $X='XX'
    $XRED='X'
    $IF($DEF(CRED))
      $IF(CRED<>'YES')
        $ERROR: REDUCED CONSTRAINT ($$CRED='YES') HAVE TO BE USED
                IF REDUCED APPROXIMATING FUNCTIONS ($$ARED='YES')
                ARE USED
        $STOP
      $ENDIF
    $ENDIF
  $ELSE 
  $ENDIF
$ELSEIF($DEF(CRED))
  $IF(CRED='YES')
    $X='XX'
    $XRED='X'
  $ELSE  
  $ENDIF
$ENDIF

$IF(KBC=0)
  $IF(MODEL='NO')
    $REPEAT
      $HELP
        NUMBER OF DIFFERENTIAL EQUATIONS
      $CHECK(NE,0,INT,1)
      $IF(NE<=0)
        $IF(DIALOG>0)
          $ERASE(NE)
        $ELSE
          $ERROR: 'NE' - NUMBER OF APPROXIMATED FUNCTIONS WAS NOT SPECIFIED
          $STOP
        $ENDIF
      $ENDIF
    $UNTIL($DEF(NE))
    $HELP
      NUMBER OF LINEAR FUNCTIONS
    $CHECK(NEL,0,INT,1)
    $IF(NE>NEL)
      $EXTREM='E'
      $SUBST('UZMODE')
    $ELSE
      $NE=NEL
    $ENDIF
  $ELSE
    $IF(NF<=100)
      $HELP
        TYPE OF OPTIMIZATION
          L - LOCAL OPTIMIZATION
          G - GLOBAL OPTIMIZATION
      $CHECK(EXTREM,'L','L\G',1,NO)
    $ELSE
      $EXTREM='L'
    $ENDIF
  $ENDIF
  $HELP
    SCALING SPECIFICATION FOR VARIABLES:
      0 - NO SCALING IS PERFORMED
      1 - SCALING FACTORS ARE DETERMINED AUTOMATICALLY
      2 - SCALING FACTORS ARE SUPPLIED BY USER
  $CHECK(NORMF,0,'0\1\2',1)
$ELSE
  $EXTREM='L'
  $NORMF=0
$ENDIF
$IF(NORMF=0)
  $XN=X
$ENDIF
$ADD(INIT)
  KDF=$KDF
  KDA=$KDA
  KDC=$KDC
  KDE=$KDE
  KDY=$KDY
$ENDADD

$IF($DEF(NA))
$NAP=NA
$ELSE
$NA=0
$NAP=0
$ENDIF
$IF($DEF(KBA))
$ELSE
  $KBA=0
$ENDIF
$IF($DEF(NC))
$NCP=NC
$ELSE
$NC=0
$NCP=0
$ENDIF
$IF($DEF(KBC))
$ELSE
  $KBC=0
$ENDIF
$MCA=0
$MCL=0
$IF($DEF(M))
  $HELP
    MAXIMUM SIZE OF ARRAYS FOR THE SPARSE GAUSSIAN ELIMINATION
  $CHECK(MMAX,M,INT,1)
$ENDIF


